Index: branches/1.3/gui/scripts/nanovisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4501)
+++ branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4504)
@@ -1,4 +1,3 @@
 # -*- mode: tcl; indent-tabs-mode: nil -*- 
-
 # ----------------------------------------------------------------------
 #  COMPONENT: nanovisviewer - 3D volume rendering
@@ -76,79 +75,90 @@
     public method isconnected {}
     public method limits { tf }
-    public method overmarker { m x }
     public method parameters {title args} { 
         # do nothing 
     }
-    public method rmdupmarker { m x }
     public method scale {args}
-    public method updatetransferfuncs {}
-
-    protected method Connect {}
-    protected method CurrentDatasets {{what -all}}
-    protected method Disconnect {}
-    protected method DoResize {}
-    protected method FixLegend {}
-    protected method AdjustSetting {what {value ""}}
-    protected method InitSettings { args }
-    protected method Pan {option x y}
-    protected method Rebuild {}
-    protected method ReceiveData { args }
-    protected method ReceiveImage { args }
-    protected method ReceiveLegend { tf vmin vmax size }
-    protected method Rotate {option x y}
-    protected method SendTransferFuncs {}
-    protected method Slice {option args}
-    protected method SlicerTip {axis}
-    protected method Zoom {option}
+    public method updateTransferFunctions {}
 
     # The following methods are only used by this class.
-    private method AddIsoMarker { x y }
+
+    private method AddNewMarker { x y } 
+    private method AdjustSetting {what {value ""}}
     private method BuildCameraTab {}
     private method BuildCutplanesTab {}
     private method BuildViewTab {}
+    private method BuildVolumeComponents {}
     private method BuildVolumeTab {}
-    private method ResetColormap { color }
-    private method ComputeTransferFunc { tf }
+    private method ComputeAlphamap { cname } 
+    private method ComputeTransferFunction { cname }
+    private method Connect {}
+    private method CurrentDatasets {{what -all}}
+    private method Disconnect {}
+    private method DoResize {}
+    private method DrawLegend { cname }
+    private method EventuallyRedrawLegend { } 
     private method EventuallyResize { w h } 
-    private method EventuallyResizeLegend { } 
-    private method NameTransferFunc { dataobj comp }
+    private method FixLegend {}
+    private method GetAlphamap { cname color } 
+    private method GetColormap { cname color } 
+    private method GetDatasetsWithComponent { cname } 
+    private method GetVolumeInfo { w }
+    private method HideAllMarkers {} 
+    private method InitComponentSettings { cname } 
+    private method InitSettings { args }
+    private method NameToAlphamap { name } 
+    private method NameTransferFunction { dataobj comp }
+    private method Pan {option x y}
     private method PanCamera {}
-    private method ParseLevelsOption { tf levels }
-    private method ParseMarkersOption { tf markers }
-    private method volume { tag name }
-    private method GetVolumeInfo { w }
+    private method ParseLevelsOption { cname levels }
+    private method ParseMarkersOption { cname markers }
+    private method Rebuild {}
+    private method ReceiveData { args }
+    private method ReceiveImage { args }
+    private method ReceiveLegend { tf vmin vmax size }
+    private method RemoveMarker { x y }
+    private method ResetColormap { cname color }
+    private method Rotate {option x y}
+    private method SendTransferFunctions {}
     private method SetOrientation { side }
+    private method Slice {option args}
+    private method SlicerTip {axis}
+    private method SwitchComponent { cname } 
+    private method ToggleVolume { tag name }
+    private method Zoom {option}
+    private method ViewToQuaternion {} { 
+        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
+    }
 
     private variable _arcball ""
 
     private variable _dlist ""     ;# list of data objects
-    private variable _allDataObjs
     private variable _obj2ovride   ;# maps dataobj => style override
     private variable _serverDatasets   ;# contains all the dataobj-component 
                                    ;# to volumes in the server
-    private variable _serverTfs    ;# contains all the transfer functions 
-                                   ;# in the server.
-    private variable _recvdDatasets    ;# list of data objs to send to server
-    private variable _dataset2style    ;# maps dataobj-component to transfunc
-    private variable _style2datasets   ;# maps tf back to list of 
-                                    # dataobj-components using the tf.
-
-    private variable _reset 1;		# Connection to server has been reset 
-    private variable _click        ;# info used for rotate operations
-    private variable _limits       ;# autoscale min/max for all axes
-    private variable _view         ;# view params for 3D view
-    private variable _isomarkers    ;# array of isosurface level values 0..1
+    private variable _recvdDatasets;    # list of data objs to send to server
+    private variable _dataset2style;    # maps dataobj-component to transfunc
+    private variable _style2datasets;   # maps tf back to list of 
+                                        # dataobj-components using the tf.
+
+    private variable _reset 1;		# Connection to server has been reset.
+    private variable _click;            # Info used for rotate operations.
+    private variable _limits;           # Autoscale min/max for all axes
+    private variable _view;             # View params for 3D view
+    private variable _parsedFunction
+    private variable _transferFunctionEditors
     private variable  _settings
-    # Array of transfer functions in server.  If 0 the transfer has been
-    # defined but not loaded.  If 1 the transfer function has been named
-    # and loaded.
-    private variable _activeTfs
-    private variable _first ""     ;# This is the topmost volume.
     private variable _alphamap
-
-    # This 
-    # indicates which isomarkers and transfer
-    # function to use when changing markers,
-    # opacity, or thickness.
+    private variable _widget
+
+    private variable _first "" ;        # This is the topmost volume.
+    private variable _current "";       # Currently selected component 
+    private variable _volcomponents   ; # Array of components found 
+    private variable _componentsList   ; # Array of components found 
+    private variable _cname2style
+    private variable _cname2transferFunction
+    private variable _cname2defaultcolormap
+    private variable _cname2defaultalphamap
+
     common _downloadPopup          ;# download options from popup
     private common _hardcopy
@@ -177,5 +187,5 @@
     $_dispatcher register !send_transfunc
     $_dispatcher dispatch $this !send_transfunc \
-        "[itcl::code $this SendTransferFuncs]; list"
+        "[itcl::code $this SendTransferFunctions]; list"
 
     # Rebuild event
@@ -196,37 +206,48 @@
     # Initialize the view to some default parameters.
     array set _view {
-        qw      0.853553
-        qx      -0.353553
-        qy      0.353553
-        qz      0.146447
-        zoom    1.0
-        xpan    0
-        ypan    0
+        -qw      0.853553
+        -qx      -0.353553
+        -qy      0.353553
+        -qz      0.146447
+        -xpan    0
+        -ypan    0
+        -zoom    1.0
     }
     set _arcball [blt::arcball create 100 100]
-    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
-    $_arcball quaternion $q
-
-    set _limits(vmin) 0.0
-    set _limits(vmax) 1.0
+    $_arcball quaternion [ViewToQuaternion]
+
+    set _limits(v) [list 0.0 1.0]
     set _reset 1
 
-    array set _settings [subst {
-        $this-qw                $_view(qw)
-        $this-qx                $_view(qx)
-        $this-qy                $_view(qy)
-        $this-qz                $_view(qz)
-        $this-zoom              $_view(zoom)    
-        $this-xpan              $_view(xpan)
-        $this-ypan              $_view(ypan)
-        $this-volume            1
-        $this-xcutplane         0
-        $this-xcutposition      0
-        $this-ycutplane         0
-        $this-ycutposition      0
-        $this-zcutplane         0
-        $this-zcutposition      0
-    }]
-
+    array set _settings {
+        -axesvisible       1
+        -colormap          default
+        -cutplanesvisible  0
+        -gridvisible       0
+        -isosurfaceshading 0
+        -legendvisible     1
+        -light2side        1
+        -outlinevisible    0
+        -qw                0.853553
+        -qx                -0.353553
+        -qy                0.353553
+        -qz                0.146447
+        -thickness         350
+        -volume            1
+        -volumeopacity     0.5
+        -volumevisible     1
+        -xcutplaneposition 50
+        -xcutplanevisible  1
+        -xpan              0
+        -ycutplaneposition 50
+        -ycutplanevisible  1
+        -ypan              0
+        -zcutplaneposition 50
+        -zcutplanevisible  1
+        -zoom              1.0
+    }
+    array set _widget {
+        -volumeopacity     50
+    }
     itk_component add 3dview {
         label $itk_component(plotarea).view -image $_image(plot) \
@@ -249,5 +270,6 @@
     }
     pack $itk_component(reset) -side top -padx 2 -pady 2
-    Rappture::Tooltip::for $itk_component(reset) "Reset the view to the default zoom level"
+    Rappture::Tooltip::for $itk_component(reset) \
+        "Reset the view to the default zoom level"
 
     itk_component add zoomin {
@@ -279,6 +301,6 @@
             -onimage [Rappture::icon volume-on] \
             -offimage [Rappture::icon volume-off] \
-            -command [itcl::code $this AdjustSetting volume] \
-            -variable [itcl::scope _settings($this-volume)]
+            -command [itcl::code $this AdjustSetting -volume] \
+            -variable [itcl::scope _settings(-volume)]
     }
     $itk_component(volume) select
@@ -286,4 +308,15 @@
         "Toggle the volume cloud on/off"
     pack $itk_component(volume) -padx 2 -pady 2
+
+    itk_component add cutplane {
+        Rappture::PushButton $f.cutplane \
+            -onimage [Rappture::icon cutbutton] \
+            -offimage [Rappture::icon cutbutton] \
+            -variable [itcl::scope _settings(-cutplanesvisible)] \
+            -command [itcl::code $this AdjustSetting -cutplanesvisible] 
+    }
+    Rappture::Tooltip::for $itk_component(cutplane) \
+        "Show/Hide cutplanes"
+    pack $itk_component(cutplane) -padx 2 -pady 2
 
     if { [catch {
@@ -298,5 +331,4 @@
 
     # Legend
-
     set _image(legend) [image create photo]
     itk_component add legend {
@@ -308,5 +340,9 @@
     }
     bind $itk_component(legend) <Configure> \
-        [itcl::code $this EventuallyResizeLegend]
+        [itcl::code $this EventuallyRedrawLegend]
+    bind $itk_component(legend) <KeyPress-Delete> \
+        [itcl::code $this RemoveMarker %x %y]
+    bind $itk_component(legend) <Enter> \
+        [list focus $itk_component(legend)]
 
     # Hack around the Tk panewindow.  The problem is that the requested 
@@ -387,6 +423,9 @@
     image delete $_image(legend)
     image delete $_image(download)
+    foreach name [array names _transferFunctionEditors] {
+        itcl::delete object $_transferFunctionEditors($cname)
+    }
     catch { blt::arcball destroy $_arcball }
-    array unset _settings $this-*
+    array unset _settings 
 }
 
@@ -420,5 +459,4 @@
     if {$pos < 0} {
         lappend _dlist $dataobj
-        set _allDataObjs($dataobj) 1
         set _obj2ovride($dataobj-color) $params(-color)
         set _obj2ovride($dataobj-width) $params(-width)
@@ -497,6 +535,6 @@
         if { $pos >= 0 } {
             set _dlist [lreplace $_dlist $pos $pos]
-            array unset _limits $dataobj*
             array unset _obj2ovride $dataobj-*
+            array unset _dataset2style $dataobj-*
             set changed 1
         }
@@ -518,28 +556,47 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::NanovisViewer::scale {args} {
-    foreach val {xmin xmax ymin ymax zmin zmax vmin vmax} {
-        set _limits($val) ""
-    }
+    array set styles {
+        -color BCGYR
+        -levels 6
+        -markers ""
+    }
+    array unset _limits 
+    array unset _volcomponents 
     foreach dataobj $args {
         if { ![$dataobj isvalid] } {
             continue;                     # Object doesn't contain valid data.
         }
+        foreach cname [$dataobj components] {
+            if { ![info exists _volcomponents($cname)] } {
+                lappend _componentsList $cname
+                array set styles [lindex [$dataobj components -style $cname] 0]
+                set cmap [ColorsToColormap $styles(-color)]
+                set _cname2defaultcolormap($cname) $cmap
+                set _settings($cname-colormap) $styles(-color)
+            }
+            lappend _volcomponents($cname) $dataobj-$cname
+            array unset limits
+            array set limits [$dataobj valueLimits $cname]
+            set _limits($cname) $limits(v)
+        }
         foreach axis {x y z v} {
             foreach { min max } [$dataobj limits $axis] break
             if {"" != $min && "" != $max} {
-                if {"" == $_limits(${axis}min)} {
-                    set _limits(${axis}min) $min
-                    set _limits(${axis}max) $max
+                if { ![info exists _limits($axis)] } {
+                    set _limits($axis) [list $min $max]
                 } else {
-                    if {$min < $_limits(${axis}min)} {
-                        set _limits(${axis}min) $min
+                    foreach {amin amax} $_limits($axis) break
+                    if {$min < $amin} {
+                        set amin $min
                     }
-                    if {$max > $_limits(${axis}max)} {
-                        set _limits(${axis}max) $max
+                    if {$max > $amax} {
+                        set amax $max
                     }
+                    set _limits($axis) [list $amin $amax]
                 }
             }
         }
     }
+    BuildVolumeComponents
 }
 
@@ -660,41 +717,9 @@
 
 # ----------------------------------------------------------------------
-# USAGE: SendTransferFuncs
-# ----------------------------------------------------------------------
-itcl::body Rappture::NanovisViewer::SendTransferFuncs {} {
-    if { $_first == "" } {
-        puts stderr "first not set"
-        return
-    }
-    # Ensure that the global opacity and thickness settings (in the slider
-    # settings widgets) are used for the active transfer-function.  Update
-    # the values in the _settings varible.
-    set opacity [expr { double($_settings($this-opacity)) * 0.01 }]
-    # Scale values between 0.00001 and 0.01000
-    set thickness [expr {double($_settings($this-thickness)) * 0.0001}]
-
-    foreach tag [CurrentDatasets] {
-        if { ![info exists _serverDatasets($tag)] || !$_serverDatasets($tag) } {
-            # The volume hasn't reached the server yet.  How did we get 
-            # here?
-            puts stderr "Don't have $tag in _serverDatasets"
-            continue
-        }
-        if { ![info exists _dataset2style($tag)] } {
-            puts stderr "don't have style for volume $tag"
-            continue;                        # How does this happen?
-        }
-        set tf $_dataset2style($tag)
-        set _settings($this-$tf-opacity) $opacity
-        set _settings($this-$tf-thickness) $thickness
-        ComputeTransferFunc $tf
-        # FIXME: Need to the send information as to what transfer functions
-        #        to update so that we only update the transfer function 
-        #        as necessary.  Right now, all transfer functions are 
-        #        updated. This makes moving the isomarker slider chunky.
-        if { ![info exists _activeTfs($tf)] || !$_activeTfs($tf) } {
-            set _activeTfs($tf) 1
-        }
-        SendCmd "volume shading transfunc $tf $tag"
+# USAGE: SendTransferFunctions
+# ----------------------------------------------------------------------
+itcl::body Rappture::NanovisViewer::SendTransferFunctions {} {
+    foreach cname [array names _volcomponents] {
+        ComputeTransferFunction $cname
     }
     FixLegend
@@ -727,23 +752,7 @@
 
 #
-# ReceiveLegend --
-#
-#       The procedure is the response from the render server to each "legend"
-#       command.  The server sends back a "legend" command invoked our
-#       the slave interpreter.  The purpose is to collect data of the image 
-#       representing the legend in the canvas.  In addition, the isomarkers
-#       of the active transfer function are displayed.
-#
-#       I don't know is this is the right place to display the isomarkers.
-#       I don't know all the different paths used to draw the plot. There's 
-#       "Rebuild", "add", etc.
-#
-itcl::body Rappture::NanovisViewer::ReceiveLegend { tf vmin vmax size } {
-    if { ![isconnected] } {
-        return
-    }
-    set bytes [ReceiveBytes $size]
-    $_image(legend) configure -data $bytes
-    ReceiveEcho <<line "<read $size bytes for [image width $_image(legend)]x[image height $_image(legend)] legend>"
+# DrawLegend --
+#
+itcl::body Rappture::NanovisViewer::DrawLegend { cname } {
     set c $itk_component(legend)
     set w [winfo width $c]
@@ -751,33 +760,38 @@
     set lx 10
     set ly [expr {$h - 1}]
-    if {"" == [$c find withtag transfunc]} {
+    if {"" == [$c find withtag colorbar]} {
         $c create image 10 10 -anchor nw \
-            -image $_image(legend) -tags transfunc
+            -image $_image(legend) -tags colorbar
         $c create text $lx $ly -anchor sw \
-            -fill $itk_option(-plotforeground) -tags "limits vmin"
+            -fill $itk_option(-plotforeground) -tags "limits text vmin"
         $c create text [expr {$w-$lx}] $ly -anchor se \
-            -fill $itk_option(-plotforeground) -tags "limits vmax"
-        $c lower transfunc
-        $c bind transfunc <ButtonRelease-1> \
-            [itcl::code $this AddIsoMarker %x %y]
-    }
-    # Display the markers used by the active transfer function.
-
-    array set limits [limits $tf]
-    $c itemconfigure vmin -text [format %g $limits(min)]
+            -fill $itk_option(-plotforeground) -tags "limits text vmax"
+        $c create text [expr {$w/2}] $ly -anchor s \
+            -fill $itk_option(-plotforeground) -tags "limits text title"
+        $c lower colorbar
+        $c bind colorbar <ButtonRelease-1> [itcl::code $this AddNewMarker %x %y]
+    }
+
+    # Display the markers used by the current transfer function.
+    HideAllMarkers
+    $_transferFunctionEditors($cname) showMarkers $_limits($cname)
+
+    foreach {min max} $_limits($cname) break
+    $c itemconfigure vmin -text [format %g $min]
     $c coords vmin $lx $ly
 
-    $c itemconfigure vmax -text [format %g $limits(max)]
+    $c itemconfigure vmax -text [format %g $max]
     $c coords vmax [expr {$w-$lx}] $ly
 
-    if { [info exists _isomarkers($tf)] } {
-        foreach m $_isomarkers($tf) {
-            $m visible yes
-        }
-    }
+    set title [$_first hints label]
+    set units [$_first hints units]
+    if { $units != "" } {
+        set title "$title ($units)"
+    }
+    $c itemconfigure title -text $title
+    $c coords title [expr {$w/2}] $ly
 
     # The colormap may have changed. Resync the slicers with the colormap.
     set datasets [CurrentDatasets -cutplanes]
-    SendCmd "volume data state $_settings($this-volume) $datasets"
 
     # Adjust the cutplane for only the first component in the topmost volume
@@ -787,11 +801,33 @@
         # Turn off cutplanes for all volumes
         SendCmd "cutplane state 0 $axis"
-        if { $_settings($this-${axis}cutplane) } {
+        if { $_settings(-${axis}cutplanevisible) } {
             # Turn on cutplane for this particular volume and set the position
             SendCmd "cutplane state 1 $axis $tag"
-            set pos [expr {0.01*$_settings($this-${axis}cutposition)}]
+            set pos [expr {0.01*$_settings(-${axis}cutplaneposition)}]
             SendCmd "cutplane position $pos $axis $tag"
         }
     }
+}
+
+#
+#
+# ReceiveLegend --
+#
+#       The procedure is the response from the render server to each "legend"
+#       command.  The server sends back a "legend" command invoked our
+#       the slave interpreter.  The purpose is to collect data of the image 
+#       representing the legend in the canvas.  In addition, the
+#       active transfer function is displayed.
+#
+#
+itcl::body Rappture::NanovisViewer::ReceiveLegend { cname vmin vmax size } {
+    if { ![isconnected] } {
+        return
+    }
+    set bytes [ReceiveBytes $size]
+    $_image(legend) configure -data $bytes
+    ReceiveEcho <<line "<read $size bytes for [image width $_image(legend)]x[image height $_image(legend)] legend>"
+
+    DrawLegend $_current
 }
 
@@ -833,18 +869,13 @@
     set dataobj [lindex $parts 0]
     set _serverDatasets($tag) 1
-    if { $_settings($this-volume) && $dataobj == $_first } {
+    if { $_settings(-volumevisible) && $dataobj == $_first } {
         SendCmd "volume state 1 $tag"
     }
-    set _limits($tag-min)  $info(min);  # Minimum value of the volume.
-    set _limits($tag-max)  $info(max);  # Maximum value of the volume.
-    set _limits(vmin)      $info(vmin); # Overall minimum value.
-    set _limits(vmax)      $info(vmax); # Overall maximum value.
+    set _limits($tag) [list $info(min)  $info(max)]
+    set _limits(v)    [list $info(vmin) $info(vmax)]
 
     unset _recvdDatasets($tag)
     if { [array size _recvdDatasets] == 0 } {
-        # The active transfer function is by default the first component of
-        # the first data object.  This assumes that the data is always
-        # successfully transferred.
-        updatetransferfuncs
+        updateTransferFunctions
     }
 }
@@ -869,13 +900,4 @@
     # generates a new call to Rebuild).   
     StartBufferingCommands
-
-    # Hide all the isomarkers. Can't remove them. Have to remember the
-    # settings since the user may have created/deleted/moved markers.
-
-    foreach tf [array names _isomarkers] {
-        foreach m $_isomarkers($tf) {
-            $m visible no
-        }
-    }
 
     if { $_width != $w || $_height != $h || $_reset } {
@@ -895,4 +917,9 @@
                     }
                     set data [$dataobj blob $cname]
+                    if 0 {
+                        set f [open "/tmp/values-$cname.txt" "w"]
+                        puts $f [$dataobj values $cname]
+                        close $f
+                    }
                 } else {
                     set data [$dataobj vtkdata $cname]
@@ -920,5 +947,5 @@
                 set _serverDatasets($tag) 0
             }
-            NameTransferFunc $dataobj $cname
+            NameTransferFunction $dataobj $cname
         }
     }
@@ -928,24 +955,29 @@
 	# Reset the camera and other view parameters
 	#
-        set _settings($this-qw)    $_view(qw)
-        set _settings($this-qx)    $_view(qx)
-        set _settings($this-qy)    $_view(qy)
-        set _settings($this-qz)    $_view(qz)
-	set _settings($this-xpan)  $_view(xpan)
-	set _settings($this-ypan)  $_view(ypan)
-	set _settings($this-zoom)  $_view(zoom)
-
-        set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+        set _settings(-qw)    $_view(-qw)
+        set _settings(-qx)    $_view(-qx)
+        set _settings(-qy)    $_view(-qy)
+        set _settings(-qz)    $_view(-qz)
+	set _settings(-xpan)  $_view(-xpan)
+	set _settings(-ypan)  $_view(-ypan)
+	set _settings(-zoom)  $_view(-zoom)
+
+        set q [ViewToQuaternion]
         $_arcball quaternion $q
         SendCmd "camera orient $q"
         SendCmd "camera reset"
 	PanCamera
-	SendCmd "camera zoom $_view(zoom)"
-        InitSettings light2side light transp isosurface grid axes 
+	SendCmd "camera zoom $_view(-zoom)"
 	
+        #cutplane state 0 all
         foreach axis {x y z} {
             # Turn off cutplanes for all volumes
             SendCmd "cutplane state 0 $axis"
         }
+
+        InitSettings -light2side -light -volumeopacity \
+            -isosurfaceshading -gridvisible -axesvisible \
+            -current
+
 	if {"" != $_first} {
 	    set axis [$_first hints updir]
@@ -960,5 +992,5 @@
     }
     # Outline seems to need to be reset every update.
-    InitSettings outline
+    InitSettings -outlinevisible -cutplanesvisible 
     # nothing to send -- activate the proper ivol
     SendCmd "volume state 0"
@@ -972,5 +1004,5 @@
         set cname [lindex [$_first components] 0]
         if { [info exists _serverDatasets($_first-$cname)] } {
-            updatetransferfuncs
+            updateTransferFunctions
         }
     }
@@ -1021,22 +1053,22 @@
     switch -- $option {
         "in" {
-            set _view(zoom) [expr {$_view(zoom)*1.25}]
-            set _settings($this-zoom) $_view(zoom)
-            SendCmd "camera zoom $_view(zoom)"
+            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
+            set _settings(-zoom) $_view(-zoom)
+            SendCmd "camera zoom $_view(-zoom)"
         }
         "out" {
-            set _view(zoom) [expr {$_view(zoom)*0.8}]
-            set _settings($this-zoom) $_view(zoom)
-            SendCmd "camera zoom $_view(zoom)"
+            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
+            set _settings(-zoom) $_view(-zoom)
+            SendCmd "camera zoom $_view(-zoom)"
         }
         "reset" {
             array set _view {
-                qw      0.853553
-                qx      -0.353553
-                qy      0.353553
-                qz      0.146447
-                zoom    1.0
-                xpan   0
-                ypan   0
+                -qw      0.853553
+                -qx      -0.353553
+                -qy      0.353553
+                -qz      0.146447
+                -xpan    0
+                -ypan    0
+                -zoom    1.0
             }
             if { $_first != "" } {
@@ -1046,15 +1078,15 @@
                 }
             }
-            set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+            set q [ViewToQuaternion]          
             $_arcball quaternion $q
             SendCmd "camera orient $q"
             SendCmd "camera reset"
-            set _settings($this-qw)    $_view(qw)
-            set _settings($this-qx)    $_view(qx)
-            set _settings($this-qy)    $_view(qy)
-            set _settings($this-qz)    $_view(qz)
-            set _settings($this-xpan)  $_view(xpan)
-            set _settings($this-ypan)  $_view(ypan)
-            set _settings($this-zoom)  $_view(zoom)
+            set _settings(-qw)    $_view(-qw)
+            set _settings(-qx)    $_view(-qx)
+            set _settings(-qy)    $_view(-qy)
+            set _settings(-qz)    $_view(-qz)
+            set _settings(-xpan)  $_view(-xpan)
+            set _settings(-ypan)  $_view(-ypan)
+            set _settings(-zoom)  $_view(-zoom)
         }
     }
@@ -1062,8 +1094,6 @@
 
 itcl::body Rappture::NanovisViewer::PanCamera {} {
-    #set x [expr ($_view(xpan)) / $_limits(xrange)]
-    #set y [expr ($_view(ypan)) / $_limits(yrange)]
-    set x $_view(xpan)
-    set y $_view(ypan)
+    set x $_view(-xpan)
+    set y $_view(-ypan)
     SendCmd "camera pan $x $y"
 }
@@ -1104,9 +1134,9 @@
 
                 set q [$_arcball rotate $x $y $_click(x) $_click(y)]
-                foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
-                set _settings($this-qw) $_view(qw)
-                set _settings($this-qx) $_view(qx)
-                set _settings($this-qy) $_view(qy)
-                set _settings($this-qz) $_view(qz)
+                foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
+                set _settings(-qw) $_view(-qw)
+                set _settings(-qx) $_view(-qx)
+                set _settings(-qy) $_view(-qy)
+                set _settings(-qz) $_view(-qz)
                 SendCmd "camera orient $q"
 
@@ -1141,9 +1171,9 @@
         set x [expr $x / double($w)]
         set y [expr $y / double($h)]
-        set _view(xpan) [expr $_view(xpan) + $x]
-        set _view(ypan) [expr $_view(ypan) + $y]
+        set _view(-xpan) [expr $_view(-xpan) + $x]
+        set _view(-ypan) [expr $_view(-ypan) + $y]
         PanCamera
-        set _settings($this-xpan) $_view(xpan)
-        set _settings($this-ypan) $_view(ypan)
+        set _settings(-xpan) $_view(-xpan)
+        set _settings(-ypan) $_view(-ypan)
         return
     }
@@ -1158,9 +1188,9 @@
         set _click(x) $x
         set _click(y) $y
-        set _view(xpan) [expr $_view(xpan) - $dx]
-        set _view(ypan) [expr $_view(ypan) - $dy]
+        set _view(-xpan) [expr $_view(-xpan) - $dx]
+        set _view(-ypan) [expr $_view(-ypan) - $dy]
         PanCamera
-        set _settings($this-xpan) $_view(xpan)
-        set _settings($this-ypan) $_view(ypan)
+        set _settings(-xpan) $_view(-xpan)
+        set _settings(-ypan) $_view(-ypan)
     }
     if { $option == "release" } {
@@ -1194,6 +1224,41 @@
     }
     switch -- $what {
-        light {
-            set val $_settings($this-light)
+        "-axesvisible" {
+            SendCmd "axis visible $_settings($what)"
+        }
+        "-colormap" {
+            set color [$itk_component(colormap) value]
+            set _settings($what) $color
+            set _settings($_current${what}) $color
+            ResetColormap $_current $color
+        }
+        "-current" {
+            set cname [$itk_component(volcomponents) value]
+            SwitchComponent $cname
+        }
+        "-cutplanesvisible" {
+            set bool $_settings($what)
+            set datasets [CurrentDatasets -cutplanes]
+            set tag [lindex $datasets 0]
+            SendCmd "cutplane visible $bool $tag"
+        }
+        "-gridvisible" {
+            SendCmd "grid visible $_settings($what)"
+        }
+        "-isosurfaceshading" {
+            SendCmd "volume shading isosurface $_settings($what)"
+        }
+        "-legendvisible" {
+            if { $_settings($what) } {
+                blt::table $itk_component(plotarea) \
+                    0,0 $itk_component(3dview) -fill both \
+                    1,0 $itk_component(legend) -fill x 
+                blt::table configure $itk_component(plotarea) r1 -resize none
+            } else {
+                blt::table forget $itk_component(legend)
+            }
+        }
+        "-light" {
+            set val $_settings($what)
             set diffuse [expr {0.01*$val}]
             set ambient [expr {1.0-$diffuse}]
